#include "libmpeg2.h"
#include "mpeg2protos.h"
#include <stdlib.h>

int main(int argc, char *argv[])
{
	mpeg2_t mpeg2_fd;
	int i, result = 0;
	long total_bytes = 0;
	unsigned char *output;
	float *audio_output_f;
	short *audio_output_i;
	mpeg2_demuxer_t *demuxer;

	if(argc < 2)
	{
		printf("Need an MPEG stream.\n");
		exit(1);
	}

	mpeg2_fd.packet_size = 0x800;
	mpeg2_fd.is_program_stream = 1;
	mpeg2_fd.is_transport_stream = 0;
	strcpy(mpeg2_fd.fs.path, argv[1]);

	demuxer = mpeg2_new_demuxer(&mpeg2_fd, 1, 0);
	while(!result)
	{
		result = mpeg2_read_program(&mpeg2_fd, demuxer);
		if(demuxer->data_size > 0)
		{
			fprintf(stderr, "result %d data size %04d total_bytes %d time %f\r", result, demuxer->data_size, total_bytes, demuxer->time);
			total_bytes += demuxer->data_size;
			fwrite(demuxer->data_buffer, demuxer->data_size, 1, stdout);
		}
	}
fprintf(stderr, "\n");

// printf("main\n");
// 	mpeg2_read_program(&mpeg2_fd, demuxer);
// printf("main\n");
// 	mpeg2_read_program(&mpeg2_fd, demuxer);
	return 0;
}
