#include "libmpeg2.h"
#include "mpeg2protos.h"

#include <stdlib.h>

mpeg2_vtrack_t* mpeg2_new_vtrack(mpeg2_t *file)
{
	int result = 0;
	mpeg2_vtrack_t *new_vtrack;
	new_vtrack = malloc(sizeof(mpeg2_vtrack_t));
	new_vtrack->demuxer = mpeg2_new_demuxer(file, 0, 1);
	new_vtrack->current_position = 0;

// Get information about the track here.
	new_vtrack->video = mpeg2video_new(file, new_vtrack);

	if(!new_vtrack->video)
	{
// Failed
		mpeg2_delete_vtrack(file, new_vtrack);
		new_vtrack = 0;
	}
	return new_vtrack;
}

int mpeg2_delete_vtrack(mpeg2_t *file, mpeg2_vtrack_t *vtrack)
{
	mpeg2video_delete(vtrack->video);
	mpeg2_delete_demuxer(file, vtrack->demuxer);
	free(vtrack);
}
