#include "pluginprefs.h"
#include "preferences.h"

PluginPrefs::PluginPrefs(PreferencesWindow *pwindow)
 : BC_SubWindow(150, 10, PREFSUBWINDOW_W, PREFSUBWINDOW_H, MEGREY)
{ this->pwindow = pwindow; }

PluginPrefs::~PluginPrefs()
{
	delete ipath;
	delete ipathtext;
	delete lpath;
	delete lpathtext;
}

int PluginPrefs::create_objects()
{
	char string[1024];
	
	add_border(get_resources()->get_bg_shadow1(),
		get_resources()->get_bg_shadow2(),
		get_resources()->get_bg_color(),
		get_resources()->get_bg_light2(),
		get_resources()->get_bg_light1());
	add_tool(new BC_Title(10, 5, "Plugins", LARGEFONT, RED));
	add_tool(new BC_Title(10, 35, "Look for global plugins here", MEDIUMFONT, BLACK));
	add_tool(new BC_Title(10, 95, "Look for personal plugins here", MEDIUMFONT, BLACK));

	add_tool(ipathtext = new PluginGlobalPathText(pwindow, pwindow->global_plugin_dir));
	add_tool(ipath = new PluginGlobalPath(pwindow, ipathtext, pwindow->global_plugin_dir));

	add_tool(lpathtext = new PluginLocalPathText(pwindow, pwindow->local_plugin_dir));
	add_tool(lpath = new PluginLocalPath(pwindow, lpathtext, pwindow->local_plugin_dir));
}






PluginGlobalPath::PluginGlobalPath(PreferencesWindow *pwindow, BC_TextBox *textbox, char *text)
 : BrowseButton(215, 55, textbox, text, "Global Plugin Path", "Select the directory for plugins", 1)
{ this->pwindow = pwindow; }

PluginGlobalPath::~PluginGlobalPath() {}

PluginGlobalPathText::PluginGlobalPathText(PreferencesWindow *pwindow, char *text)
 : BC_TextBox(10, 55, 200, text)
{ this->pwindow = pwindow; }

PluginGlobalPathText::~PluginGlobalPathText() {}

int PluginGlobalPathText::handle_event()
{
	strcpy(pwindow->global_plugin_dir, get_text());
}




PluginLocalPath::PluginLocalPath(PreferencesWindow *pwindow, BC_TextBox *textbox, char *text)
 : BrowseButton(215, 115, textbox, text, "Personal Plugin Path", "Select the directory for plugins", 1)
{ this->pwindow = pwindow; }

PluginLocalPath::~PluginLocalPath() {}

PluginLocalPathText::PluginLocalPathText(PreferencesWindow *pwindow, char *text)
 : BC_TextBox(10, 115, 200, text)
{ this->pwindow = pwindow; }

PluginLocalPathText::~PluginLocalPathText() {}

int PluginLocalPathText::handle_event()
{
	strcpy(pwindow->local_plugin_dir, get_text());
}
