#ifndef PLUGINPREFS_H
#define PLUGINPREFS_H

class PluginGlobalPath;
class PluginGlobalPathText;
class PluginLocalPath;
class PluginLocalPathText;

#include "browsebutton.h"
#include "preferences.inc"

class PluginPrefs : public BC_SubWindow
{
public:
	PluginPrefs(PreferencesWindow *pwindow);
	~PluginPrefs();
	
	int create_objects();
	PreferencesWindow *pwindow;
// must delete each derived class
	PluginGlobalPath *ipath;
	PluginGlobalPathText *ipathtext;
	PluginLocalPath *lpath;
	PluginLocalPathText *lpathtext;
};





class PluginGlobalPath : public BrowseButton
{
public:
	PluginGlobalPath(PreferencesWindow *pwindow, BC_TextBox *textbox, char *text);
	~PluginGlobalPath();
	
	PreferencesWindow *pwindow;
};



class PluginGlobalPathText : public BC_TextBox
{
public:
	PluginGlobalPathText(PreferencesWindow *pwindow, char *text);
	~PluginGlobalPathText();
	int handle_event();
	PreferencesWindow *pwindow;
};






class PluginLocalPath : public BrowseButton
{
public:
	PluginLocalPath(PreferencesWindow *pwindow, BC_TextBox *textbox, char *text);
	~PluginLocalPath();
	
	PreferencesWindow *pwindow;
};



class PluginLocalPathText : public BC_TextBox
{
public:
	PluginLocalPathText(PreferencesWindow *pwindow, char *text);
	~PluginLocalPathText();
	int handle_event();
	PreferencesWindow *pwindow;
};

#endif
