#ifndef PREVIEWAUDIO_H
#define PREVIEWAUDIO_H

#include "audiodevice.inc"
#include "bcbase.h"
#include "file.inc"
#include "mutex.h"
#include "pluginbuffer.inc"
#include "record.inc"
#include "recordengine.inc"
#include "thread.h"




class PreviewAudio : public Thread
{
public:
	PreviewAudio(Record *record, RecordEngine *engine);
	~PreviewAudio();

	int set_parameters(BC_Meter **meter, AudioDevice *device, long buffer_size, long sample_rate);
	int start_preview(long position, File *file);
	int stop_preview();



	int arm_buffer();
	int update_current_position();
	long get_current_position();
	long absolute_position();

	void run();

// meter information
	int FRAGMENTS;
	int total_peaks;
	float **peak_history;
	long *peak_sample;
	int current_peak, output_peak, last_peak;
	BC_Meter **meter;


	Mutex preview_complete;
	PluginBuffer *shared_output[MAXCHANNELS];
	float *output[MAXCHANNELS];
	long buffer_size, fragment_size;
	long preview_start, current_position, preview_end;
	int playback_channels;
	int is_previewing, is_last_buffer;
	AudioDevice *device;
	RecordEngine *engine;
	Record *record;
	File *file;
};


class PreviewPosition : public Thread
{
public:
	PreviewPosition(PreviewAudio *engine);
	~PreviewPosition();

	void run();
	PreviewAudio *thread;
};

#endif
