#ifndef RECORDPREFS_H
#define RECORDPREFS_H

class RecordInPath;
class RecordInBits;
class RecordInChannels;
class DuplexOutPath;
class DuplexOutBits;
class DuplexOutChannels;
class DuplexEnable;
class RecordMinDB;
class RecordVUDB;
class RecordVUInt;
class RecordWriteLength;
class RecordRealTime;

#include "preferences.inc"


class RecordPrefs : public BC_SubWindow
{
public:
	RecordPrefs(PreferencesWindow *pwindow);
	~RecordPrefs();

	int create_objects();
	PreferencesWindow *pwindow;
// must delete each derived class
	RecordInPath *inpath;
	RecordInBits *inbits;
	RecordInChannels *inchannels;
	DuplexOutPath *outpath;
	DuplexOutBits *outbits;
	DuplexOutChannels *outchannels;
	RecordWriteLength *write_length;
	DuplexEnable *duplexenable;
	RecordRealTime *realtime;
};


class RecordInPath : public BC_TextBox
{
public:
	RecordInPath(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class RecordInBits : public BC_TextBox
{
public:
	RecordInBits(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class RecordInChannels : public BC_TextBox
{
public:
	RecordInChannels(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};



class DuplexOutPath : public BC_TextBox
{
public:
	DuplexOutPath(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class DuplexOutBits : public BC_TextBox
{
public:
	DuplexOutBits(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class DuplexOutChannels : public BC_TextBox
{
public:
	DuplexOutChannels(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class RecordWriteLength : public BC_TextBox
{
public:
	RecordWriteLength(PreferencesWindow *pwindow, char *text);
	int handle_event();
	PreferencesWindow *pwindow;
};

class DuplexEnable : public BC_CheckBox
{
public:
	DuplexEnable(PreferencesWindow *pwindow, int value);
	int handle_event();
	PreferencesWindow *pwindow;
};

class RecordRealTime : public BC_CheckBox
{
public:
	RecordRealTime(PreferencesWindow *pwindow, int value);
	int handle_event();
	PreferencesWindow *pwindow;
};

#endif
