#ifndef VIDEOPREFS_H
#define VIDEOPREFS_H

#include "preferences.inc"

class VideoFastest;
class VideoAlphaChannels;
class VideoFloatingPoint;
class VideoInterpolate;


class VideoPrefs : public BC_SubWindow
{
public:
	VideoPrefs(PreferencesWindow *pwindow);
	~VideoPrefs();

	int create_objects();
	int draw_framerate();
	int set_optimizations(int fastest, int alphachannels, int floatingpoint, int interpolate);

	PreferencesWindow *pwindow;
	BC_Title *frame_rate;
	VideoFastest *fastest;
	VideoAlphaChannels *alphachannels;
	VideoFloatingPoint *floatingpoint;
	VideoInterpolate *interpolate;
};





class VideoEveryFrame : public BC_CheckBox
{
public:
	VideoEveryFrame(PreferencesWindow *pwindow, int y);
	~VideoEveryFrame();

	int handle_event();
	PreferencesWindow *pwindow;
};



class VideoReadLength : public BC_TextBox
{
public:
	VideoReadLength(PreferencesWindow *pwindow, int y);
	~VideoReadLength();

	int handle_event();
	PreferencesWindow *pwindow;
};



class VideoOutputLength : public BC_TextBox
{
public:
	VideoOutputLength(PreferencesWindow *pwindow, int y);
	~VideoOutputLength();

	int handle_event();
	PreferencesWindow *pwindow;
};

class VideoRateReset : public BC_BigButton
{
public:
	VideoRateReset(PreferencesWindow *pwindow, int y, VideoPrefs *prefs);
	~VideoRateReset();
	int handle_event();
	PreferencesWindow *pwindow;
	VideoPrefs *prefs;
};

class VideoInterpolate : public BC_Radial
{
public:
	VideoInterpolate(PreferencesWindow *pwindow, int y, VideoPrefs *prefs);
	~VideoInterpolate();

	int handle_event();
	PreferencesWindow *pwindow;
	VideoPrefs *prefs;
};

class VideoFloatingPoint : public BC_Radial
{
public:
	VideoFloatingPoint(PreferencesWindow *pwindow, int y, VideoPrefs *prefs);
	~VideoFloatingPoint();

	int handle_event();
	PreferencesWindow *pwindow;
	VideoPrefs *prefs;
};

class VideoAlphaChannels : public BC_Radial
{
public:
	VideoAlphaChannels(PreferencesWindow *pwindow, int y, VideoPrefs *prefs);
	~VideoAlphaChannels();

	int handle_event();
	PreferencesWindow *pwindow;
	VideoPrefs *prefs;
};

class VideoFastest : public BC_Radial
{
public:
	VideoFastest(PreferencesWindow *pwindow, int y, VideoPrefs *prefs);
	~VideoFastest();

	int handle_event();
	PreferencesWindow *pwindow;
	VideoPrefs *prefs;
};

class VideoPlaybackDevice : public BC_TextBox
{
public:
	VideoPlaybackDevice(PreferencesWindow *pwindow, int y);
	~VideoPlaybackDevice();

	int handle_event();
	PreferencesWindow *pwindow;
};

class VideoRecordDevice : public BC_TextBox
{
public:
	VideoRecordDevice(PreferencesWindow *pwindow, int y);
	~VideoRecordDevice();

	int handle_event();
	PreferencesWindow *pwindow;
};

class VideoDriverText : public BC_PopupMenu
{
public:
// set wr to 1 for writable file formats
	VideoDriverText(int x, int y, char *text, PreferencesWindow *pwindow);
	~VideoDriverText();

	int handle_event();  // user copies text to value here
	int add_items();         // add initial items
	PreferencesWindow *pwindow;
};

class VideoDriverItem : public BC_PopupItem
{
public:
	VideoDriverItem(VideoDriverText *popup, char *text, int driver);
	~VideoDriverItem();

	int handle_event();
	VideoDriverText *popup;
	int driver;
};

class VideoWriteLength : public BC_TextBox
{
public:
	VideoWriteLength(PreferencesWindow *pwindow, char *text, int y);
	int handle_event();
	PreferencesWindow *pwindow;
};

class VideoCaptureLength : public BC_TextBox
{
public:
	VideoCaptureLength(PreferencesWindow *pwindow, char *text, int y);
	int handle_event();
	PreferencesWindow *pwindow;
};



#endif
