#include "bccolors.h"
#include "bcipc.h"
#include "bcresources.h"
#include "bcwindow.h"
#include <stdio.h>
#include <X11/extensions/XShm.h>
#include <sys/ipc.h>
#include <sys/shm.h>

int bc_error = 0;

int bcresources_error(Display *display, XErrorEvent *event)
{
	bc_error = 1;
	return 0;
}

BC_Resources::BC_Resources(BC_Window *window)
{
	use_shm = 1;

// Set up IPC cleanup handlers
	bc_init_ipc();

// Test for shm
	XSetErrorHandler(bcresources_error);
	if(!XShmQueryExtension(window->display)) use_shm = 0;
	else
	{
		XShmSegmentInfo test_shm;
		XImage *test_image;
		unsigned char *data;
		test_image = XShmCreateImage(window->display, window->vis, window->depth,
                ZPixmap, (char*)NULL, &test_shm, 5, 5);

		test_shm.shmid = shmget(IPC_PRIVATE, 5 * test_image->bytes_per_line, (IPC_CREAT | 0777 ));
		data = (unsigned char *)shmat(test_shm.shmid, NULL, 0);
		bc_error = 0;
 	   	XShmAttach(window->display, &test_shm);
    	XSync(window->display, False);
		if(bc_error) use_shm = 0;
		XDestroyImage(test_image);
		shmdt(test_shm.shmaddr);
    	shmctl(test_shm.shmid, IPC_RMID, 0);
	}

// Initialize
	bc_error = 0;
	bg_color = MEGREY;
	bg_shadow1 = DKGREY;
	bg_shadow2 = BLACK;
	bg_light1 = WHITE;
	bg_light2 = bg_color;

	button_light = WHITE;           // bright corner
	button_highlighted = LTGREY;  // face when highlighted
	button_down = MDGREY;         // face when down
	button_up = MEGREY;           // face when up
	button_shadow = DKGREY;       // dark corner

	menu_light = LTCYAN;
	menu_highlighted = LTBLUE;
	menu_down = MDCYAN;
	menu_up = MECYAN;
	menu_shadow = DKCYAN;

	text_default = BLACK;
	text_background = WHITE;
	highlight_inverse = WHITE ^ BLUE;

	double_click = 300;

	sprintf(large_font, "-*-charter-*-r-*-*-24-*-*-*-*-*-*-*");
	//sprintf(large_font, "-*-helvetica-bold-r-normal--24-240-75-75-p-124-iso8859-1");
	sprintf(medium_font, "-*-helvetica-bold-r-normal-*-14-*");
	sprintf(small_font, "-*-helvetica-medium-r-normal-*-10-*");
}

BC_Resources::~BC_Resources()
{
}

int BC_Resources::get_bg_color()
{ return bg_color; }

int BC_Resources::get_bg_shadow1()
{ return bg_shadow1; }

int BC_Resources::get_bg_shadow2()
{ return bg_shadow2; }

int BC_Resources::get_bg_light1()
{ return bg_light1; }

int BC_Resources::get_bg_light2()
{ return bg_light2; }

