#ifndef SHARPEN_H
#define SHARPEN_H

// the simplest plugin possible
// Sharpen leaves the last line too bright

class SharpenMain;
#define MAXSHARPNESS 100

#include "bcbase.h"
#include "sharpenwindow.h"
#include "pluginvclient.h"


class SharpenMain : public PluginVClient
{
public:
	SharpenMain(int argc, char *argv[]);
	~SharpenMain();

// required for all realtime plugins
	int process_realtime(long size, VFrame **input_ptr, VFrame **output_ptr);
	int plugin_is_realtime();
	int plugin_is_multi_channel();
	char* plugin_title();
	int start_realtime();
	int stop_realtime();
	int start_gui();
	int stop_gui();
	int show_gui();
	int hide_gui();
	int set_string();
	int save_data(char *text);
	int read_data(char *text);
	int load_defaults();
	int save_defaults();

// parameters needed for sharpness
	float sharpness; // Range from 0 to 100
	float last_sharpness;

// a thread for the GUI
	SharpenThread *thread;

private:
	int filter(int w, VPixel *src, VPixel *dst,
		int *neg0, int *neg1, int *neg2);
	int get_luts(int *pos_lut, int *neg_lut);

	int pos_lut[VMAX + 1],  neg_lut[VMAX + 1];
	VPixel *src_rows[4], *dst_row;
	int *neg_rows[4];
	Defaults *defaults;
};


#endif
