#include "libmpeg2.h"
#include "mpeg2protos.h"
#include <stdlib.h>

int main(int argc, char *argv[])
{
	mpeg2_t mpeg2_fd;
	int i, result = 0;
	long total_bytes = 0;
	unsigned char *output;
	float *audio_output_f;
	short *audio_output_i;
	mpeg2_demuxer_t *demuxer;
	int do_audio = 0, do_video = 0;

	if(argc < 3)
	{
		printf("Extract either the audio or the video from a movie to stdout.\n");
		printf("Usage: mpeg2split -[av] <movie>\n");
		printf("Example: mpeg2split -a xena.vob > war_cry.mp2\n");
		exit(1);
	}

	for(i = 1; i < argc; i++)
	{
		if(argv[i][0] == '-')
		{
			if(argv[i][1] == 'a') do_audio = 1;
			else
			if(argv[i][1] == 'v') do_video = 1;
			else
			fprintf(stderr, "invalid option %s\n", argv[i]);
		}
		else
			strcpy(mpeg2_fd.fs.path, argv[i]);
	}

	mpeg2_fd.packet_size = 0x800;
	mpeg2_fd.is_program_stream = 1;
	mpeg2_fd.is_transport_stream = 0;

	demuxer = mpeg2_new_demuxer(&mpeg2_fd, do_audio, do_video);
	while(!result)
	{
		result = mpeg2_read_program(demuxer);
		if(demuxer->data_size > 0)
		{
//			fprintf(stderr, "result %d data size %04d total_bytes %d timestamp %f\r", result, demuxer->data_size, total_bytes, demuxer->time);
			total_bytes += demuxer->data_size;
//			fwrite(demuxer->data_buffer, demuxer->data_size, 1, stdout);
		}
	}
	fprintf(stderr, "\n");
	return 0;
}
