#include <stdio.h>
#include <stdlib.h>
#include <time.h>


static unsigned long  mpeg2_MMX_80w[]    = {0x00800080, 0x00800080};                     //dd    00080 0080h, 000800080h
static unsigned long  mpeg2_MMX_00FFw[]  = {0x00ff00ff, 0x00ff00ff};                     //dd    000FF 00FFh, 000FF00FFh
static unsigned short mpeg2_MMX_UtoG[]   = {0xffe8, 0xffe8, 0xffe8, 0xffe8};             //dd    0FFE7 FFE7h, 0FFE7FFE7h
static unsigned short mpeg2_MMX_UtoB[]   = {0x81, 0x81, 0x81, 0x81};                     //dd    00081 0081h, 000810081h
static unsigned short mpeg2_MMX_VtoG[]   = {0xffcd, 0xffcd, 0xffcd, 0xffcd};             //dd    0FFCC FFCCh, 0FFCCFFCCh
static unsigned short mpeg2_MMX_VtoR[]   = {0x66, 0x66, 0x66, 0x66};                     //dd    00066 0066h, 000660066h
static unsigned short mpeg2_MMX_Y[]      = {0x4a, 0x4a, 0x4a, 0x4a};                     //dd    0004A 004Ah, 0004A004Ah

void inline mpeg2_bgra32_mmx(unsigned char *lum, unsigned char *cr, unsigned char *cb, unsigned char *row1)
{
	asm("
// Do firswt 4 
            movd	   (%1),		      %%mm0;  // Load u  0  0  0  0  0  0 u1 u0
            movd	   (%0),		      %%mm1;  // Load v  0  0  0  0 v3 v2 v1 v0
            punpcklbw  %%mm7,		      %%mm0;  // Unpack u	0 u3  0 u2  0 u1  0 u0
			punpcklbw  %%mm7,		      %%mm1;  // Unpack v	0 v3  0 v2  0 v1  0 v0
            psubw	   mpeg2_MMX_80w,     %%mm0;  // Subtract 0x80 from each pixel
            psubw	   mpeg2_MMX_80w,     %%mm1;

            movq	   %%mm0,		      %%mm2;  // Make a copy of cb 0 u3  0 u2  0 u1  0 u0
            movq	   %%mm1,		      %%mm3;  // Make a copy of cr
            pmullw     mpeg2_MMX_UtoG,    %%mm2;  // Convert Cb to green 0 R3  0 R2  0 R1  0 R0
            movq       (%2),              %%mm6;  // Load L1  L7 L6 L5 L4 L3 L2 L1 L0
            pmullw     mpeg2_MMX_UtoB,    %%mm0;  // Convert Cb to blue
            pand       mpeg2_MMX_00FFw,   %%mm6;  // Take only half of L  00 L6 00 L4 00 L2 00 L0
            pmullw     mpeg2_MMX_VtoG,    %%mm3;  // Convert Cr to green
            movq       (%2),              %%mm7;  // Load L2
            pmullw     mpeg2_MMX_VtoR,    %%mm1;  // Convert Cr to red
            psrlw	   $8,  			  %%mm7;  // Shift L2 to less significant 00 L7 00 L5 00 L3 00 L1
            pmullw     mpeg2_MMX_Y,       %%mm6;  // Scale L1
            paddw      %%mm3,             %%mm2;  // Cb2green + Cr2green == green
            pmullw     mpeg2_MMX_Y,       %%mm7;  // Scale L2

            movq       %%mm6,             %%mm4;  // Make a copy of L1
            paddw      %%mm0,             %%mm6;  // Add L1 + blue  00 B6 00 B4 00 B2 00 B0
            movq       %%mm4,             %%mm5;  // Make another copy of lum1
            paddw      %%mm1,             %%mm4;  // Add L1 + red   00 R6 00 R4 00 R2 00 R0
            paddw      %%mm2,             %%mm5;  // Add L1 + green 00 G6 00 G4 00 G2 00 G0
            psraw      $6,                %%mm4;  // Scale R1 down
            movq       %%mm7,             %%mm3;  // Make a copy of L2  00 L7 00 L5 00 L3 00 L1
            psraw      $6,                %%mm5;  // Scale G1 down
            paddw      %%mm0,             %%mm7;  // Add L2 + blue 00 B7 00 B5 00 B3 00 B1
            psraw      $6,                %%mm6;  // Scale B1 down
            packuswb   %%mm4,             %%mm4;  // Pack R1 R1
            packuswb   %%mm5,			  %%mm5;  // Pack G1 G1
            packuswb   %%mm6,			  %%mm6;  // Pack B1 B1
	"
	:
	: "r" (cr), "r" (cb), "r" (lum), "r" (row1));
}

void inline mpeg2_bgra32_single_mmx(unsigned char *lum, unsigned char *cr, unsigned char *cb, unsigned char *output)
{
}


int main(int argc, char *argv[])
{
	unsigned char ycrcb[8] = { 1, 2, 3, 0, 0, 0, 0, 0 };
	unsigned char bgra[8];
	short r, g, b, a;

	printf("%02x%02x%02x%02x%02x%02x%02x%02x\n", ycrcb[0], ycrcb[1], ycrcb[2], ycrcb[3], ycrcb[4], ycrcb[5], ycrcb[6], ycrcb[7]);
	mpeg2_bgra32_mmx(ycrcb, bgra);
//	p3[0] = p3[1] = p3[2] = p3[4] = p3[5] = p3[6] = p3[7] = 0;
//	result = mmx_test(p3);
	printf("%02x%02x%02x%02x%02x%02x%02x%02x\n", bgra[0], bgra[1], bgra[2], bgra[3], bgra[4], bgra[5], bgra[6], bgra[7]);
	b = *(short*)&bgra[0];
	g = *(short*)&bgra[2];
	r = *(short*)&bgra[4];
	a = *(short*)&bgra[6];
	printf("%d %d %d %d\n", b, g, r, a);
}
