#ifndef ARENDER_H
#define ARENDER_H

#include "arender.inc"
#include "audiodevice.inc"
#include "file.inc"
#include "mainwindow.inc"
#include "mutex.h"
#include "thread.h"

class ARender : public Thread
{
public:
	ARender(MainWindow *mwindow);
	~ARender();

	int arm_playback();
	int stop_playback();   // interrupt while playing
	int close_playback();
	void run();
	int wait_for_startup();
	int wait_for_completion();
	int reset_parameters();

	MainWindow *mwindow;
	long current_sample;
	long buffer_length;
	char* buffer;
	long bytes;
	File *file;
	Mutex startup_lock;
	AudioDevice *audio;
	int BUFFER_SIZE;
};



#endif
