#ifndef FILEMPEG_H
#define FILEMPEG_H

#include "file.inc"
#include "filebase.h"
#include "libmpeg2.h"

class FileMPEG : public FileBase
{
public:
	FileMPEG(Asset *asset, File *file);
	~FileMPEG();

	int open_file();
	int close_file_derived();
	int read_header();
	long get_video_length();
	long get_audio_length();
	long get_video_position();
	long get_audio_position();
	int set_video_position(long x);
	int set_audio_position(long x);
	int read_raw(char *buffer, long len);
	int frame_buffer_copy_possible(int color_model);
	int translate_color_model(int color_model);
	int read_frame_buffer(unsigned char **frame_buffer, int w, int h, int bitmap_color_model);
	int read_frame(unsigned char *frame);
	int load_into_ram();

private:
	int reset_parameters_derived();
// current positions for when the file descriptor doesn't have the right position
	long audio_position;
	long video_position;
	mpeg2_t *file;
};





#endif
